<?php
Library::import('recess.framework.controllers.Controller');
Library::import('blog.models.Author');

/**
 * !RespondsWith Layouts
 * !Prefix Routes: /, Views: authors/
 */
class AuthorsController extends Controller {

	/** !Route GET, authors */
	public function listAuthors(){
		$author = new Author();
		$this->authors = $author->all();
	}
	
	/** !Route GET, authors/$id */
	public function show($id){
		$author = new Author($id);
		$this->author = $author->find()->first();
	}
	
	/** !Route GET, authors/new */
	public function newAuthor(){
		$this->author = new Author();
	}
	
	/** !Route POST, authors */
	public function create(){
		$author = new Author($this->request->post['author']);
		
		if( $author->save() ){
			return $this->redirect($this->urlTo('listAuthors'));
		} else {
			return $this->ok('newAuthor');
		}
	}
	
	/** !Route GET, authors/$id/edit */
	public function edit($id){
		$author = new Author($id);
		
		if( $author->exists() ){
			$this->author = $author->find()->first();
		} else {
			return $this->redirect($this->urlTo('listAuthors'));
		}
	}
	
	/** !Route PUT, authors/$id */
	public function update($id){
		$author = new Author($id);
		
		if( $author->exists() ){
			$this->author = $author->find()->first()->copy($this->request->put['author']);
			if( $this->author->save() ){
				//set a success message if necessary
			}
			return $this->redirect($this->urlTo('edit',$id));
		} else {
			return $this->redirect($this->urlTo('listAuthors'));
		}
	}
	
	/**
	 * !Route DELETE, authors/$id
	 * !Route GET, authors/$id/delete
	 */
	public function delete($id){
		$author = new Author($id);
		
		if( $author->exists() ) $author->delete();
		return $this->redirect($this->urlTo('listAuthors'));
	}
	
}

?>